/*
Copyright 2020 Peter Howkins

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
#include "basic.h"

int
main(void)
{
	MODE(1);
	CLS();

	// Text mode output
	{
		PRINT("Hello, World!");

		COLOUR(1);
		PRINTTAB(0, 2, "Hello, Red");

		// This should move the text cursor without outputing anything
		PRINTTAB(3, 3, "");

		COLOUR(2);
		PRINT("Hello, Yellow");
	}

	// Sound
	{
		SOUND(1, -15, 53, 20);

		uint8_t envelope_data[14] = { 1, 1, -1,  1, -1, 64, 128, 64, 126,  -4, -1,  -4, 126,  80 };
		ENVELOPE(envelope_data);
		SOUND(1, 1, 8, 20);
	}

	// Graphics output
	{
		// Draw a box on the screen
		GCOL(0, 3);
		MOVE(8,    168);
		DRAW(1268, 168);
		DRAW(1268, 440);
		DRAW(8,    440);
		DRAW(8,    168);

		// Draw and Move are aliases to the underlying more versatile Plot command
		GCOL(0, 1);
		PLOT(4, 24,   184);
		PLOT(5, 1252, 184);
		PLOT(5, 1252, 424);
		PLOT(5, 24,   424);
		PLOT(5, 24,   184);
	}

	// Input
	{
		COLOUR(3);
		PRINT("Press space bar to continue");

		do {
		} while(!INKEYNEG(-99));
	}

	return 0;
}
